Summary: Application layer proxy toolkit.
Name: openfwtk
Release: 3
Version: %{fwversion}
License: BSD
Group: System Environment/Daemons
Source: openfwtk-%{version}.tar.gz
Prereq: fileutils coreutils grep /etc/init.d
BuildRequires: openssl-devel ncurses-devel file db4-devel
Requires: openssl >= 0.9.8
Requires: file >= 4.17
Requires: db4 >= 4.0
Requires: ncurses >= 5.0
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root

%package -n ssl-proxy
Summary:	%{fwvendor} http/https application proxy
Group: 		System Environment/Daemons
Requires(post): /sbin/chkconfig
Requires(preun): /sbin/chkconfig
Requires(preun): /sbin/service

%description
Application proxy toolkit which inherits the ideology of TIS fwtk and maintains API backwards compatibility. The design goal is to make it simple yet powerful; no performance hacks allowed in the code and library dependencies are reduced to minimum.

%description -n ssl-proxy
This package includes %{fwvendor} http/https application proxy.

%prep
%setup -q

%build
make PREFIX=/opt/firewall

%install
rm -rf $RPM_BUILD_ROOT
mkdir -p $RPM_BUILD_ROOT{/opt/firewall/etc/keys,/opt/firewall/bin,/opt/firewall/man/man{3,5,8},/opt/firewall/var/run,/opt/firewall/var/spool,/opt/firewall/var/tmp}

chmod 1777 $RPM_BUILD_ROOT/opt/firewall/var/run $RPM_BUILD_ROOT/opt/firewall/var/tmp
make install PREFIX=$RPM_BUILD_ROOT/opt/firewall INSTALLADD=""

install -m644 config-samples/netperm-table $RPM_BUILD_ROOT/opt/firewall/etc

mkdir -p $RPM_BUILD_ROOT/etc/rc.d/init.d
install -m755 dist/Linux-RedHat/http-gw.init $RPM_BUILD_ROOT/etc/rc.d/init.d/http-gw
install -m755 dist/Linux-RedHat/ftp-gw.init $RPM_BUILD_ROOT/etc/rc.d/init.d/ftp-gw
install -m755 dist/Linux-RedHat/nntp-gw.init $RPM_BUILD_ROOT/etc/rc.d/init.d/nntp-gw
install -m755 dist/Linux-RedHat/pop3-gw.init $RPM_BUILD_ROOT/etc/rc.d/init.d/pop3-gw
install -m755 dist/Linux-RedHat/smtpd.init $RPM_BUILD_ROOT/etc/rc.d/init.d/smtpd
install -m755 dist/Linux-RedHat/smtpfwdd.init $RPM_BUILD_ROOT/etc/rc.d/init.d/smtpfwdd

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add syslog
echo "OFWTKPATH=\"/opt/firewall\"" > /etc/openfwtk.conf
chmod 1777 /opt/firewall/var/run /opt/firewall/var/tmp /opt/firewall/var/spool

%preun
if [ $1 = 0 ]; then
   service http-gw stop >/dev/null 2>&1
   /sbin/chkconfig --del syslog
fi

%postun
if [ "$1" -ge "1" ]; then
	service http-gw condrestart > /dev/null 2>&1
fi

%files
%defattr(-,root,root)
%doc AUTHORS LICENSE INSTALL 
%config(noreplace) /opt/firewall/etc/netperm-table
%config(noreplace) /opt/firewall/etc/keys
%dir /opt/firewall/var/run
%dir /opt/firewall/var/spool
%dir /opt/firewall/var/tmp
%config /etc/rc.d/init.d/http-gw
%config /etc/rc.d/init.d/ftp-gw
%config /etc/rc.d/init.d/pop3-gw
%config /etc/rc.d/init.d/nntp-gw
%config /etc/rc.d/init.d/smtpd
%config /etc/rc.d/init.d/smtpfwdd
/opt/firewall/bin/*
/opt/firewall/man/*
%config(noreplace) /opt/firewall/etc/alerts.add
%config(noreplace) /opt/firewall/etc/frequentcheck.ignore
%config(noreplace) /opt/firewall/etc/securityalerts.ignore
%config(noreplace) /opt/firewall/etc/securitywarnings.ignore
%config(noreplace) /opt/firewall/etc/syserr.ignore
%config(noreplace) /opt/firewall/etc/warnings.add

%files -n ssl-proxy
%defattr(-,root,root)
%config(noreplace) /opt/firewall/etc/netperm-table
%config(noreplace) %dir /opt/firewall/etc/keys
%dir /opt/firewall/var/run
%dir /opt/firewall/var/spool
%dir /opt/firewall/var/tmp
%config /etc/rc.d/init.d/http-gw
%config /etc/rc.d/init.d/pop3-gw
%config /etc/rc.d/init.d/smtpd
%config /etc/rc.d/init.d/smtpfwdd
/opt/firewall/bin/http-gw
/opt/firewall/bin/pop3-gw
/opt/firewall/bin/smtpd
/opt/firewall/bin/smtpfwdd
/opt/firewall/bin/ssmtp
/opt/firewall/man/man8/http-gw.8
/opt/firewall/man/man8/pop3-gw.8
/opt/firewall/man/man8/smtpd.8
/opt/firewall/man/man8/smtpfwdd.8
/opt/firewall/man/man8/ssmtp.8
/opt/firewall/man/man5/netperm-table.5

%changelog
* Sun Aug 23 2009 ArkanoiD <arkenoi@gmail.com> 
- Version number 2.1 is more correct
- Better certificate handling and Pathfinder integration

* Wed Jul  1 2009 ArkanoiD <arkenoi@gmail.com> 
- Initial attempt to create RedHat package

