/* assert.c */

/* Copyright 1997 by Eberhard Mattes <mattes@azu.informatik.uni-stuttgart.de>
   Donated to the public domain.  No warranty.

   1997-07-27 Initial version */

#include <unistd.h>
#include <syslog.h>
#include "firewall.h"
#include "libemfw.h"

/* This function is called by the DEBUG_ASSERT() and ALWAYS_ASSERT()
   macros if the assertion fails. */

void em_assert (const char *exp, const char *fname, unsigned int line)
{
  syslog (LLEV, "Assertion failed: %.256s, file %.256s, line %u",
	  exp, fname, line);
  _exit (3);
}
