/*
 * OpenFWTK SSL wrapper header file
 *
 * (C) Copyright 2002-2009 ArkanoiD <ark@eltex.ru>
 *
 */

#ifdef  OpenBSD
#include        <ssl/x509.h>
#include        <ssl/err.h>
#include        <ssl/ssl.h>
#else
#include        <openssl/x509.h>
#include        <openssl/err.h>
#include        <openssl/ssl.h>
#endif

extern 	SSL_CTX			*proxy_SSLCTX;
extern	STACK_OF(X509_NAME) 	*proxy_SSLcertnames;
extern	char			*proxy_SSLciphers;
extern	EVP_PKEY		*proxy_SSLkey;

#define PROXYSSL_CHECK_VRFY(p,r) ((r != X509_V_OK) && \
		  ((!strcmp(p,"strict")) || \
		   ((!strcmp(p,"basic")) && \
		    (r != X509_V_ERR_UNABLE_TO_GET_ISSUER_CERT) && \
		    (r != X509_V_ERR_CERT_NOT_YET_VALID) && \
		    (r != X509_V_ERR_CERT_HAS_EXPIRED) && \
		    (r != X509_V_ERR_DEPTH_ZERO_SELF_SIGNED_CERT) && \
		    (r != X509_V_ERR_SELF_SIGNED_CERT_IN_CHAIN) && \
		    (r != X509_V_ERR_UNABLE_TO_GET_ISSUER_CERT_LOCALLY))) )
			   

int 	proxy_SSLcheck_cert(SSL *ssl,const char *host,const char *vrfy, char *buf);
void 	proxy_SSLinit();
void 	proxy_SSLdeinit();
SSL* 	proxy_SSLaccept(int fd,char *rladdr,char *riaddr,char *cvrfy,X509 *cert,EVP_PKEY *key );
SSL* 	proxy_SSLconnect(int fd, char *dst, char *svrfy,X509 *cert,EVP_PKEY *key);
int	proxy_SSLread(SSL *conn, char *buf, int buflen);
int	proxy_SSLwrite(SSL *conn, const char *buf, int buflen);
X509* 	proxy_SSLread_cert(const char *sslcertfile);
EVP_PKEY* proxy_SSLread_key(const char *keyfile);
X509*	proxy_SSLconf_cert(const char *sslcertname);
EVP_PKEY* proxy_SSLconf_key(const char *keyname);
X509*	proxy_SSLspoof_server_cert(SSL *srvsession);
X509*	proxy_SSL_makeup_error_cert(const char *srvname);
