/*
 * Copyright 2009,2010 Security Technology Research
 * All rights reserved. 
 */

#define MAX_CONTENT_LENGTH   (1024LL * 1024 * 1024 * 1024)

/* This structure holds data extracted from the request header. */

struct request_state
{
  unsigned method_flags;
  int chunked;			
  int has_body;
  int user_agent_seen;
  char *user_agent;
  long long content_length;
  const char *method_name;
  octet ipaddr[4];		/* For CONNECT */
  int port;			/* For CONNECT */
  char http_version[3+1];	/* For CONNECT, e.g. "1.1" */
};

/* This structure holds data extracted from the response header. */

struct response_state
{
  int code;			/* -1 while processing request */
  int chunked;			
  long long content_length;
  char *content_type;
  const char *content_encoding;
  int charset_type; 		 /* Charset type (for multibyte encodings) */
};

typedef enum
{
        IN,
        OUT,
        NONE

} direction;


void http_parse_response (struct hdr_line *headers);
char* http_save (char *template, EMI_FILE *src, int chunked, long long size);
void http_copy (EMO_FILE *, int, EMI_FILE *, int, long long , direction);
void http_write_header (EMO_FILE *, const struct hdr_line*);
