/*
 * Copyright 2009 Security Technology Research
 * All rights reserved. 
 */


/* Copyright 1997-2000 by Eberhard Mattes <em-gw@windhager.de>
   Donated to the public domain.  No warranty.
*/

/* Flags for url_parse(). */

#define UPF_WILDCARD		0x01
#define UPF_NODEFPORT		0x02

/* Flags for url_compare(). */

/* TODO: Currently, UCF_WILDCARD implies UCF_IGNORE_CASE */

#define UCF_IGNORE_CASE		0x01
#define UCF_EXACT		0x02
#define UCF_WILDCARD		0x04

/* Output of url_parse(). */

struct url
{
  enum
  {
    URL_CACHE_OBJECT,
    URL_CLSID,
    URL_FILE,
    URL_FTP,
    URL_GOPHER,
    URL_HTTP,
    URL_HTTPS,
    URL_ICAP,
    URL_JAVA,
    URL_JAVASCRIPT,
    URL_MAILTO,
    URL_MILTER,
    URL_NEWS,
    URL_NNTP,
    URL_PROSPERO,
    URL_TELNET,
    URL_WAIS,
    URL_NO_SCHEME,
    URL_OTHER_SCHEME,
    URL_WILDCARD,
    URL_HTTP_OR_HTTPS,
    URL_EMPTY
  } scheme;
  int scheme_start;
  int scheme_length;
  int user_start;
  int user_length;
  int password_start;
  int password_length;
  int host_start;
  int host_length;
  int port_start;
  int port_length;
  int path_start;
  int path_length;
  int query_start;
  int query_length;
  int fragment_start;
  int fragment_length;
  int type_start;
  int type_length;
  int total_length;
  long port;
};

int url_parse (struct url *, const octet *, int, unsigned);
int url_decode (char *, int, const char *, int);
int url_compare (const octet *, const struct url *,
		 const octet *, const struct url *, unsigned);

