/*
 * ms-sql-gw, a Tabular DataStream v4.2 and 4.6 proxy designed to work
 *		with TIS fwtk
 *
 * (C) Copyright 1999 by ArkanoiD <ark@eltex.ru>
 * Version 0.4beta
 *
 */

#include	<stdio.h>
#include	<string.h>
#include	<syslog.h>
#include	<sys/types.h>
#include	<sys/time.h>
#include	<sys/socket.h>
#include	<netinet/in.h>
#include	<arpa/inet.h>
#ifdef AIX
#include	<sys/select.h>
#endif
#include	<netdb.h>
#include	<netinet/in.h>
#include	<errno.h>
//#include	<md5.h>
#include	<signal.h>
#include	<sys/ioctl.h>

#ifdef  USE_SSL
#include        <openssl/x509.h>
#include        <openssl/err.h>
#include        <openssl/ssl.h>
#endif

#include        "firewall.h"
#include        "auth.h"
#ifdef  OpenBSD
#include        <ssl/blowfish.h>
#include        <ssl/md5.h>
#else
#include        <openssl/blowfish.h>
#include        <openssl/md5.h>
#endif
#include        "fwfunc.h"
#include        "firewall2.h"
#ifdef  USE_SSL
#include        "sslfunc.h"
#endif

#include	"firewall.h"
#include	"blowfish.h"

#define         CRYPT_NONE      000
#define         CRYPT_BF        001
#define         CRYPT_3DES      002
#define         CRYPT_GOST      003

extern 			h_errno;
extern	void		waitwaitwait();

static	char		rladdr[512];
static	char		riaddr[512];

static	char		plug_server[512] ="";
static	char		dest[512] ="none";

static	time_t		start_time;
static	time_t		end_time;
static	int		ib = 0;
static	int		ob = 0;
static	int		timeout = PROXY_TIMEOUT;
	pid_t		ccrypto_pid = 0;
	pid_t		scrypto_pid = 0;

static	Cfg		*confp;
static	char		**validdests = (char **)0;
static	char		**validusers = (char **)0;

	int		extendperm = 0;
	int		transparent = 0;
	int		loguser = 0;
static	char		authuser[128] = "unauth";

#define TDS_4_2		42
#define TDS_4_6		46

	int		tds_version = TDS_4_2;

	int		send_oob = 0;
	int		server_port = 1433;

static  int             net_write();
static  int             net_read();

static  BF_KEY          cl_bfkey, srv_bfkey;
static  char            cl_bfiiv[8]  = "\0\0\0\0\0\0\0\0";
static  char            cl_bfoiv[8]  = "\0\0\0\0\0\0\0\0";
static  char            srv_bfiiv[8] = "\0\0\0\0\0\0\0\0";
static  char            srv_bfoiv[8] = "\0\0\0\0\0\0\0\0";

	int             client_encrypt = CRYPT_NONE;
	int             server_encrypt = CRYPT_NONE;
        MD5_CTX         md5_ctx;
        char            md5_digest[16];
        u_int16_t       blksize;
        u_int16_t       datasize;
        int             srv_bfiinum = 0, srv_bfoinum = 0;
        int             cl_bfiinum  = 0, cl_bfoinum  = 0;

/*
 *	Tabular DataStream packet header
 */

#define	MSG_QUERY	0x01
#define	MSG_LOGIN	0x02
#define	MSG_STRPROC	0x03
#define	MSG_REPLY	0x04
#define	MSG_CANCEL	0x06
#define	MSG_NEWLOGIN	0x10
#define	MSG_MAXTYPE	0x32

#pragma pack(1)

typedef	struct {
	unsigned	char	msgtype;
	unsigned	char	last_frag;
	unsigned	short	length;
	unsigned	short	channel;
	unsigned	char	pktnum;
	unsigned	char	window;
} tds_header;

/*
 *	TDS 4.2 (Sybase < 10, MS SQL <= 6) login packet
 */

typedef	struct {
			char	hostName[30];
	unsigned	char	hostName_l;
			char	userName[30];
	unsigned	char	userName_l;
			char	password[30];
	unsigned	char	password_l;
			char	hostProcess[30];
	unsigned	char	hostProcess_l;
	unsigned	char	int2type;
	unsigned	char	int4type;
	unsigned	char	chartype;
	unsigned	char	flttype;
	unsigned	char	datetype;
	unsigned	char	dbnotify;
	unsigned	char	bulk_copy;
	unsigned	char	iftype;
	unsigned	char	conntype;
	u_int32_t		magic_x;
			char	magic_3[3];
			char	appName[30];
	unsigned	char	appName_l;
			char	serverName[30];
	unsigned	char	serverName_l;
			char	password_1[255];
	unsigned	char	password_1_l;
	unsigned	char	protocol_version[4];
			char	DBlibName[10];
	unsigned	char	DBlibName_l;
	u_int16_t		pgmMajorversion;	
	u_int16_t		pgmMinorversion;	
	unsigned	char	s_autoconv;
	unsigned	char	flt4type;
	unsigned	char	date4type;
			char	language[30];
	unsigned	char	language_l;
	unsigned	char	suppressLanguage;
	u_int16_t		seclabel_h;
			char	security[8];
	u_int16_t		securitySpare;
	unsigned	char	securityLoginRole;
			char	charset[30];
	unsigned	char	charset_l;
	unsigned	char	suppressCharset;
			char	blocksize[6];
	unsigned	char	blocksize_l;
			char	magic_8[8];
} tds42_login;

/*
 *	TDS 4.6 (MS SQL 7.0) login packet
 */

typedef	struct {
			char	hostName[30];
	unsigned	char	hostName_l;
			char	userName[30];
	unsigned	char	userName_l;
			char	password[30];
	unsigned	char	password_l;
			char	hostProcess[30];
	unsigned	char	hostProcess_l;
	unsigned	char	int2type;
	unsigned	char	int4type;
	unsigned	char	chartype;
	unsigned	char	flttype;
	unsigned	char	datetype;
	unsigned	char	dbnotify;
	unsigned	char	bulk_copy;
	unsigned	char	iftype;
	unsigned	char	conntype;
	u_int32_t		magic_x;
			char	magic_3[3];
			char	appName[30];
	unsigned	char	appName_l;
			char	serverName[30];
	unsigned	char	serverName_l;
			char	magic_y;
	unsigned	char	password_1_l;
			char	password_1[30];
			char	magic_z[223];
	unsigned	char	password_1_l_plus_2;
	unsigned	char	protocol_version[4];
			char	DBlibName[10];
	unsigned	char	DBlibName_l;
	u_int16_t		pgmMajorversion;	
	u_int16_t		pgmMinorversion;	
	unsigned	char	s_autoconv;
	unsigned	char	flt4type;
	unsigned	char	date4type;
			char	language[30];
	unsigned	char	language_l;
	unsigned	char	suppressLanguage;
	u_int16_t		seclabel_h;
			char	security[8];
	u_int16_t		securitySpare;
	unsigned	char	securityLoginRole;
			char	charset[30];
	unsigned	char	charset_l;
	unsigned	char	suppressCharset;
			char	blocksize[6];
	unsigned	char	blocksize_l;
			char	magic_8[4];
} tds46_login;


#pragma pack()

static void
accept_setdest(v, c)
char	*v;
int	c;
{

	int	dests = 0;
	if (validdests == (char **)0)
		validdests = (char **)malloc(sizeof(char *) * 2);
	else {
		validdests = (char **)realloc(validdests,(dests + 2) * sizeof(char *));
	}
	if (validdests == (char **)0) {
		syslog(LLEV,"fwtksyserr: cannot allocate memory");
		exit(1);
	}
	validdests[dests] = v;
	validdests[dests + 1] = (char *)0;
	dests++;
}

static void
accept_setuser(v, c)
char	*v;
int	c;
{

	int	users = 0;
	if (validusers == (char **)0)
		validusers = (char **)malloc(sizeof(char *) * 2);
	else {
		validusers = (char **)realloc(validusers,(users + 2) * sizeof(char *));
	}
	if (validusers == (char **)0) {
		syslog(LLEV,"fwtksyserr: cannot allocate memory");
		exit(1);
	}
	
	validusers[users] = v;
	validusers[users + 1] = (char *)0;
}

oktotalkto()
{
	Cfg	*cf;
	int	x;

	cf = cfg_get("hosts",confp);
	while(cf != (Cfg *)0) {
		if(cf->argc < 1)
			goto skip;

		for(x = 0; x < cf->argc && cf->argv[x][0] != '-'; x++) {
			if(hostmatch(cf->argv[x],riaddr)) {
				if(cf->flags & PERM_DENY) {
					syslog(LLEV,"deny host=%.512s/%.20s use of gateway",rladdr,riaddr);
					exit(1);
				}
				syslog(LLEV,"permit host=%.512s/%.20s use of gateway",rladdr,riaddr);
				return(acceptrule(cf) == 0);
			}
		}
skip:
		cf = cfg_get("hosts",(Cfg*)0);
	}
	syslog(LLEV,"deny host=%.512s/%.20s use of gateway",rladdr,riaddr);
	exit(1);
}

acceptrule(c)
Cfg	*c;
{
	int		x = 0;
	void		(*op)();

	for(x = 1; x < c->argc; x++) {
		if(c->argv[x][0] != '-')
			continue;

		if (!strcmp(c->argv[x], "-plug-to")) {
			x++;
			if (x >= c->argc) {
				syslog(LLEV,"fwtkcfgerr: -plug-to needs an argument, line %d",c->ln);
				exit(1);
			}
			strncpy(plug_server, c->argv[x], strlen(c->argv[x]));
			plug_server[strlen(c->argv[x])] = '\0';
			continue;
		}

		if (!strcmp(c->argv[x], "-authuser")) {
			x++;
			if (x >= c->argc) {
				syslog(LLEV,"fwtkcfgerr: -authuser needs an argument, line %d",c->ln);
				exit(1);
			}
			strncpy(authuser, c->argv[x], strlen(c->argv[x]));
			authuser[strlen(c->argv[x])] = '\0';
			continue;
		}

		if(!strcmp(c->argv[x],"-client-encrypt")) {
			if (++x >= c->argc) {
				syslog(LLEV,"fwtkcfgerr: -client-encrypt takes an argument, line %d",c->ln);
				exit (1);
			}
			if (!strcmp(c->argv[x],"blowfish"))
				client_encrypt = CRYPT_BF;
			else {
				syslog(LLEV,"fwtkcfgerr: encryption %s is not implemented, line %d",c->argv[x],c->ln);
				exit(1);
			}
			continue;
		}

		if (!strcmp(c->argv[x],"-client-md5key")) {
			if (++x >= c->argc) {
				syslog(LLEV,"fwtkcfgerr: -client-md5key takes an argument, line %d",c->ln);
				exit (1);
			}
			MD5_Init(&md5_ctx);
			MD5_Update(&md5_ctx,c->argv[x],strlen(c->argv[x]));
			MD5_Final(md5_digest,&md5_ctx);

			switch (client_encrypt) {
			case 	CRYPT_NONE:
				syslog(LLEV,"fwtkcfgerr: -client-encrypt should be specified before -client-md5key, line %d",c->ln);
				exit(1);
			case	CRYPT_BF:
				BF_set_key(&cl_bfkey,16,md5_digest);
				continue;
			}
		}

		if(!strcmp(c->argv[x],"-server-encrypt")) {
			if (++x >= c->argc) {
				syslog(LLEV,"fwtkcfgerr: -server-encrypt takes an argument, line %d",c->ln);
				exit (1);
			}
			if (!strcmp(c->argv[x],"blowfish"))
				server_encrypt = CRYPT_BF;
			else {
				syslog(LLEV,"fwtkcfgerr: encryption %s is not implemented, line %d",c->argv[x],c->ln);
				exit(1);
			}
			continue;
		}

		if (!strcmp(c->argv[x],"-server-md5key")) {
			if (++x >= c->argc) {
				syslog(LLEV,"fwtkcfgerr: -server-md5key takes an argument, line %d",c->ln);
				exit (1);
			}
			MD5_Init(&md5_ctx);
			MD5_Update(&md5_ctx,c->argv[x],strlen(c->argv[x]));
			MD5_Final(md5_digest,&md5_ctx);

			switch (server_encrypt) {
			case 	CRYPT_NONE:
				syslog(LLEV,"fwtkcfgerr: -server-encrypt should be specified before -server-md5key, line %d",c->ln);
				exit(1);
			case	CRYPT_BF:
				BF_set_key(&srv_bfkey,16,md5_digest);
				continue;
			}
		}

		if(!strcmp(c->argv[x],"-extnd")) {
			extendperm = 1;
			continue;
		}

		if(!strcmp(c->argv[x],"-transparent")) {
			transparent = 1;
			continue;
		}

		if(!strcmp(c->argv[x],"-loguser")) {
			loguser = 1;
			continue;
		}

		if(!strcmp(c->argv[x],"-oob")) {
			send_oob = 1;
			continue;
		}

		if(!strcmp(c->argv[x],"-sqlv6")) {
			tds_version = TDS_4_2;
			continue;
		}

		if(!strcmp(c->argv[x],"-tdsv42")) {
			tds_version = TDS_4_2;
			continue;
		}

		if(!strcmp(c->argv[x],"-sqlv7")) {
			tds_version = TDS_4_6;
			continue;
		}

		if(!strcmp(c->argv[x],"-tdsv46")) {
			tds_version = TDS_4_6;
			continue;
		}

		/* options that take parameters and lists */

		op = 0;
		if (!strcmp(c->argv[x],"-dest"))
			op = accept_setdest;
		if (!strcmp(c->argv[x],"-user"))
			op = accept_setuser;
		if (op == 0) {
			syslog(LLEV,"fwtkcfgerr: bad option line %d: %.512s",c->ln,c->argv[x]);
			exit(1);
		}
		if (++x >= c->argc) {
			syslog(LLEV,"fwtkcfgerr: malformed line %d: missing option",c->ln);
			exit(1);
		}
		if (!strcmp(c->argv[x],"{")) {
			while (1) {
				if (++x >= c->argc) {
					syslog(LLEV,"fwtkcfgerr: malformed line %d: missing closing brace",c->ln);
					exit(1);
				}
				if (!strcmp(c->argv[x], "}"))
					break;
				(*op)(c->argv[x], c->ln);
			}
		} else
			(*op)(c->argv[x],c->ln);
	}
	return(0);
}


void 
proxy_exit(rc)
int	rc;
{
	if (ccrypto_pid)
		kill(ccrypto_pid,SIGTERM);
	if (scrypto_pid)
		kill(scrypto_pid,SIGTERM);
	time(&end_time);
	syslog(LLEV,"exit host=%.512s/%.20s destination=%.512s in=%d out=%d duration=%d",rladdr,riaddr,dest,ib,ob,end_time - start_time);
	exit(rc);
}

void
get_server(server)
char 	*server;
{
	Cfg	*cf;
	int	x;

	cf=cfg_get("server",confp);
	while (cf != (Cfg *)0) {
		if((cf->argc < 1) || (cf->argv[0][0] == '-')) {
			syslog(LLEV,"fwtkcfgerr: missing parameter, line %d",cf->ln);
			proxy_exit(0);
		}
		if (hostmatch(cf->argv[0],server)) {
			acceptrule(cf);
			return;
		}
		cf=cfg_get("server",(Cfg *)0);
	}
}

int ctos(a)
u_char	* a;
{                                                                               
	return ((a[0] << 8) | a[1]);
}

static	int
net_read(int sock,char *buf,int buflen)
{
int	n;
	while (buflen) {
		n=read(sock,buf,buflen);
                if (n<=0) {
                        return -1;
                }
                buf+=n;
                buflen-=n;
        }
}

static int
net_write(s, buf, len, flags)
int s;
char *buf;
int len;
int flags;
{
	int nbytes = 0;
	int j;

	while (nbytes < len) {
		j = send(s, buf, len-nbytes, flags);
		if (j <= 0)
			return (nbytes ? nbytes : j);
		buf += j;
		nbytes += j;
	}
	return nbytes;
}

get_transparent_dst(dsthost)
char    *dsthost;       
{                       
        int                     len;
        struct sockaddr_in      to_addr;
#ifdef IPFILTER 
        struct sockaddr_in      from_addr;
        int                     ipfnat_fd;
        struct  natlookup       natlookup;
#endif

        bzero((char *)&to_addr, sizeof(to_addr));

        len = sizeof(to_addr);
        if (getsockname(0, (struct sockaddr *)&to_addr, &len) < 0) {
                syslog(LLEV,"fwtksyserr: getsockname() failed: %m");
                exit(1);
        }

#ifndef IPFILTER

	strncpy(dsthost,inet_ntoa(to_addr.sin_addr),sizeof(dsthost));
        return(0);

#else
    
        bzero((char *)&from_addr, sizeof(from_addr));
        if (getpeername(0, (struct sockaddr *)&from_addr, &len) < 0) {
                syslog(LLEV,"fwtksyserr: getpeername() failed: %m");
                exit(1);
        }

        natlookup.nl_inport = to_addr.sin_port;
        natlookup.nl_outport = from_addr.sin_port;
        natlookup.nl_inip = to_addr.sin_addr;
        natlookup.nl_outip = from_addr.sin_addr;
        natlookup.nl_flags = IPN_TCP;

        if ((ipfnat_fd = open(IPL_NAT, O_RDONLY)) < 0) {
                syslog(LLEV,"fwtksyserr: cannot open NAT deivce: %m");
                exit(1);
        }

	if (ioctl(ipfnat_fd, SIOCGNATL, &natlookup) == -1) {
                syslog(LLEV,"fwtksyserr: SIOCGNATL failed: %m");
                close(ipfnat_fd);
                exit(1);
        }

        strcpy(dsthost,inet_ntoa(natlookup.nl_realip));
        server_port = ntohs(natlookup.nl_realport);
        return(0);

#endif
    
}

void check_header(hdr,direction)
tds_header	*hdr;
int		direction;
{

/*	Checks performed here are embryonic,
	hope will make it better one day
*/

	if (hdr->msgtype == MSG_LOGIN) {
		syslog(LLEV,"securityalert: login packet out of sequence");
		proxy_exit(1);
	}

	if (hdr->msgtype > MSG_MAXTYPE) {
		syslog(LLEV,"TDS protocol error, invalid packet type");
		proxy_exit(1);
	}

	if (ntohs(hdr->length) < 8) {
		syslog(LLEV,"TDS protocol error, invalid packet size");
		proxy_exit(1);
	}
}

/*
 *	Somehow ugly and definitely needs some optimization.
 *	I am too lazy to do it now.
 */

int spawn_bf(fd,pipe,bfkey)
int		fd;
int		pipe[2];
BF_KEY          bfkey;
{
	fd_set		rset;
	struct	timeval	timo;
	int		x;
	char		buf[1024 * 4];
	char		encbuf[1024 * 4];
	char            bfiiv[8];
	char            bfoiv[8];
        int             bfiinum = 0, bfoinum = 0;

	signal(SIGCHLD,waitwaitwait);
	socketpair(AF_UNIX, SOCK_STREAM,0,pipe);

	if (x = fork()) {
		signal(SIGCHLD,waitwaitwait);
		return(x);
	}

	signal(SIGURG,SIG_IGN);
	bzero(bfiiv,sizeof(bfiiv));
	bzero(bfoiv,sizeof(bfoiv));

	while(1) {

		FD_ZERO(&rset);
		FD_SET(fd,&rset);
		FD_SET(pipe[1],&rset);
		timo.tv_sec = timeout;
		timo.tv_usec = 0;
		if((x = select(pipe[1]+1, &rset, NULL, NULL, &timo)) < 0) {
			if (errno != EBADF && errno != EINTR)
				syslog(LLEV,"fwtksyserr: select: %m");
			exit(1);
		} else {
			if(x == 0) {
				syslog(LLEV,"Network timeout signal after %d seconds", timeout);
				break;
			}
		}

		if (FD_ISSET(fd,&rset)) {
			ioctl(fd,FIONREAD,&x);
			if (x <= 0)
				break;
			if(net_read(fd,encbuf,sizeof(blksize)) < 0)
				break;
			BF_cfb64_encrypt(encbuf,(char *)&blksize,sizeof(blksize),&bfkey,bfiiv,&bfiinum,BF_DECRYPT);
			if ((x = ntohs(blksize)) > sizeof(encbuf)) {
				syslog(LLEV,"fwtksyserr: buffer size exceeded on network socket, protocol failed");
				break;
			}
			if (net_read(fd,encbuf,x) < 0) {
				syslog(LLEV,"error reading encrypted data");
				break;
			}
			BF_cfb64_encrypt(encbuf,buf,x,&bfkey,bfiiv,&bfiinum,BF_DECRYPT);
			if(write(pipe[1],buf,x) != x)
				break;
		}

		if (FD_ISSET(pipe[1],&rset)) {
			int x1;
			ioctl(pipe[1],FIONREAD,&x);
			if (x <= 0) 
				break;
			if ((x = read(pipe[1],buf,sizeof(buf))) <= 0) 
				break;
			blksize = htons(x);
			BF_cfb64_encrypt((char *)&blksize,(char *)&x1,sizeof(blksize),&bfkey,bfoiv,&bfoinum,BF_ENCRYPT);
			BF_cfb64_encrypt(buf,encbuf,x,&bfkey,bfoiv,&bfoinum,BF_ENCRYPT);
			if(net_write(fd,&x1,sizeof(blksize),0) < sizeof(blksize)) 
				break;
			bcopy(encbuf,buf,sizeof(buf));
			if(net_write(fd,buf,x,0) != x) {
				break;
			}
		}
	}
	close(pipe[0]);
	close(pipe[1]);
	close(fd);
}

check_dest(host)
char    *host;
{
        char    buffer[1024];

        if(validdests != (char **)0) {
                char    **xp;
                int     x;

                for(xp = validdests; *xp != (char *)0; xp++) {
                        if(**xp == '!' && hostmatch(*xp + 1,host)) {
                                syslog(LLEV,"deny host=%.512s/%.20s connect to %.512s",rladdr,riaddr,host);
                                return(1);
                        } else if(hostmatch(*xp,host))
                                break;
                }
                if(*xp == (char *)0) {
                        syslog(LLEV,"deny host=%.512s/%.20s connect to %.512s",rladdr,riaddr,host);
                        return(1);
                }
        }
        if(extendperm) {
                switch (auth_perm(confp, authuser, "ms-sql-gw", host,(char *)0)) {
                case -1:
                        syslog(LLEV,"no match for ms-sql-gw user=%.100s in netperm-table",authuser);
                        return(1);
                case 1:
                        syslog(LLEV,"deny host=%.512s/%.20s connect to %.512s user=%.100s",rladdr,riaddr,host,authuser);
                        return(1);
                }
        }
	get_server(host);
        syslog(LLEV,"permit host=%.512s/%.20s connect to %.512s/%d",rladdr,riaddr,host,server_port);
        return(0);
}

check_user(user)
char    *user;
{
        char    buffer[1024];                   

        if(validusers != (char **)0) {
                char    **xp;
                int     x;        

                for(xp = validusers; *xp != (char *)0; xp++) {
                        if(**xp == '!' && !strcmp(*xp + 1,user)) {
                                return(1);
                        } else if(!strcmp(*xp,user) || !strcmp(*xp,"*"))
                                break;
                }
                if(*xp == (char *)0) {
                        return(1);
                }
        }
        return(0);
}


void login_failure(client_fd)
int	client_fd;
{
	tds_header	header;

/*
 *	This is "pre-built" error packet indicating login failure.
 *	Should be compatible for 4.2 and 4.6 protocols though login packets
 *	are different and definitely not compatible.
 *      Some magic is kept inside (the packet is just a dump of "real" server
 *	login failure notification.
 */

	char		bad_login[39] = { 0xaa,      	 /* TDS_ERR_TOKEN	*/
					  0x1b,0,	 /* length 27 		*/
					  0xa2,0x0f,0,0, /* message 4002 	*/
					  0x01,		 /* state 1 		*/
					  0x0e,		 /* level 14 	 	*/
					  0x0f,0,0x20,

					  /* "Login failed\r"            	*/

					  0x4c,0x6f,0x67,0x69,0x6e,0x20,0x66,0x61,
					  0x69,0x6c,0x65,0x64,0x0d,

					  /* some more magic (wonder if something
					     actually uses it			*/

					  0x0a,0,0,0,0,0xfd,0x02,0,0,0,0,0,0,0 	};

	header.msgtype = MSG_REPLY;
	header.last_frag = 1;
	header.pktnum = 0;
	header.channel = 0;
	header.length = htons(sizeof(tds_header)+sizeof(bad_login));
	write(client_fd,&header,sizeof(tds_header));
	write(client_fd,bad_login,sizeof(bad_login));
}


void parse_login_packet(buffer,username)
char	*buffer;
char	*username;
{
	tds42_login	*login42;
	tds46_login	*login46;

	if (tds_version == TDS_4_2) {
		login42 = (tds42_login *)buffer;
		if (login42->userName_l > 30) {
			syslog(LLEV,"protocol error: username too long");
			proxy_exit(1);
		}
		strncpy(username,login42->userName,login42->userName_l);
		return;
	}
	
	if (tds_version == TDS_4_6) {
		login46 = (tds46_login *)buffer;
		if (login46->userName_l > 30) {
			syslog(LLEV,"protocol error: username too long");
			proxy_exit(1);
		}
		strncpy(username,login46->userName,login46->userName_l);
		return;
	}
}

void set_username(buffer,username)
char	*buffer;
char	*username;
{
	tds42_login	*login42;
	tds46_login	*login46;

	if (tds_version == TDS_4_2) {
		login42 = (tds42_login *)buffer;
		bzero(login42->userName,30);
		strncpy(login42->userName,username,strlen(username));
		login42->userName_l = strlen(username);
		return;
	}
	
	if (tds_version == TDS_4_6) {
		login46 = (tds46_login *)buffer;
		bzero(login46->userName,30);
		strncpy(login46->userName,username,strlen(username));
		login46->userName_l = strlen(username);
		return;
	}
}

void get_login_packet(client_fd,buffer)
int	client_fd;
char	*buffer;
{
	char		*rdata;
	int		pkt_size;
	int		login_size;
	tds_header	header;
	tds42_login	*login42;
	tds46_login	*login46;
	int		x = 0;
	char		user[30];
					
	rdata = buffer;
	bzero(user,sizeof(user));

/*
 *	Looks just like max. login packet size
 *	Trailing magic may be truncated.
 */

	login_size = ((tds_version == TDS_4_6) ? sizeof(tds46_login) : sizeof(tds42_login));

	while ( x< login_size ) {
		if (net_read(client_fd,(char *)&header,sizeof(header)) < 0)
			break;
		if (header.msgtype != MSG_LOGIN) {
			syslog(LLEV,"protocol error: bad packet type on login sequence");
			proxy_exit(1);
		}
		if ((pkt_size = ntohs(header.length) - 8) > (login_size - x)) {
			syslog(LLEV,"fwtksyserr: buffer size exceeded on client socket, protocol failed");
			proxy_exit(1);
		}
		if (pkt_size <= 0) {
			syslog(LLEV,"protocol error: malformed login packet");
			proxy_exit(1);
		}
		if (net_read(client_fd,rdata,pkt_size) < 0)
			break;;
		x += pkt_size;
		rdata += pkt_size;
		if (header.last_frag) 
			break;
	}

	if (x <= 0) 
		proxy_exit(1);
	
	if (x < login_size - 4) {
		syslog(LLEV,"protocol error: login packet too short");
		proxy_exit(1);
	}
	if (tds_version == TDS_4_2) {
		login42 = (tds42_login *)buffer;
		if (strncmp(login42->protocol_version,"\04\02\0\0",4)) {
			syslog(LLEV,"protocol version mismatch: 4.2 (0) expected, got %d.%d (%#X)",
				    login42->protocol_version[0],login42->protocol_version[1],
				    login42->protocol_version[2] & 0xffff);
			proxy_exit(1);
		}
		if (login42->userName_l > 30) {
			syslog(LLEV,"protocol error: username too long");
			proxy_exit(1);
		}
		strncpy(user,login42->userName,login42->userName_l);
	} else {
		login46 = (tds46_login *)buffer;
		if (strncmp(login46->protocol_version,"\04\06\0\0",4)) {
			syslog(LLEV,"protocol version mismatch: 4.6 (0) expected, got %d.%d (%#X)",
				    login46->protocol_version[0],login46->protocol_version[1],
				    login46->protocol_version[2] & 0xffff);
			proxy_exit(1);
		}
		if (login46->userName_l > 30) {
			syslog(LLEV,"protocol error: username too long");
			proxy_exit(1);
		}
		strncpy(user,login46->userName,login46->userName_l);
	}
}

void send_login_packet(server_fd,buffer)
int	server_fd;
char	*buffer;
{
	char		*wdata;
	int		pkt_size;
	tds_header	header;
	int		x = 0;

	wdata = buffer;
	header.msgtype = MSG_LOGIN;
	header.pktnum = 1;
	header.channel = 0;
	header.window = 0;
	while (x < sizeof(tds42_login)) {
		if ((pkt_size = sizeof(tds42_login) - x) > (512 - 8)) {
			header.last_frag = 0;
			pkt_size = 512 - 8;
		} else
			header.last_frag = 1;
		header.pktnum++;
		header.length = htons(pkt_size+8);
		if (write(server_fd,&header,sizeof(tds_header)) < sizeof(tds_header)) {
			syslog(LLEV,"protocol error: cannot send login packet");
			proxy_exit(1);
		}
		if (write(server_fd,wdata,pkt_size) < pkt_size) {
			syslog(LLEV,"protocol error: cannot send login packet");
			proxy_exit(1);
		}
		x += pkt_size;
		ob += pkt_size;
		wdata += pkt_size;
	}
}
		

main(ac,av)
int	ac;
char	*av[];
{
	Cfg		*cf;
	char		pkt_type,last_flag;
	int		pkt_size;
	int		data_size;
	char		magic[4];
	tds_header	*header;
	char		*data;
	char		buffer[1024*8+8];
	int		x;
	int		client_fd;
	int		server_fd;
	int		server_fds;
	int		client_pipe[2];
	int		server_pipe[2];
	struct	timeval	timo;
	fd_set		rset;
	fd_set		xset;
	int		opt = 1;
	int		optlen = sizeof(opt);
	char		username[30];
	char		*p;

#ifndef	LOG_DAEMON
	openlog("ms-sql-gw",LOG_PID);
#else
	openlog("ms-sql-gw",LOG_PID|LOG_NDELAY,LFAC);
#endif

/*	if (ac > 2 && !strcmp(av[1], "-daemon")) {
		int port = str_to_port(av[2]);
		portid = port;

		ac -= 2;
		av += 2;

		syslog(LLEV,"Starting daemon mode on port %d",port);
		do_daemon(port);
	}
*/

	if((confp = cfg_read("ms-sql-gw")) == (Cfg *)-1)
		exit (1);

	if(peername(0,rladdr,riaddr,sizeof(rladdr))) {
		syslog(LLEV,"cannot get remote host: %m");
		exit(1);
	}

	if((cf = cfg_get("timeout",confp)) != (Cfg *)0) {
		if(cf->argc != 1) {
			syslog(LLEV,"fwtkcfgerr: timeout must have one parameter, line %d",cf->ln);
			exit(1);
		}
		timeout = atoi(cf->argv[0]);
	}

	if (!oktotalkto())
		exit(1);

	time(&start_time);
	memset(buffer,0,sizeof(buffer));

/*	Ugly
 *	struct looks better here but i am too lazy to do it now
 */
	header = (tds_header *) buffer;
	data = (char *) (buffer+sizeof(tds_header)) ;

	switch (client_encrypt) {
	case 	CRYPT_NONE:
		client_fd = 0;
		break;
	case	CRYPT_BF:
		ccrypto_pid = spawn_bf(0,client_pipe,cl_bfkey);
		client_fd = client_pipe[0];
	}

	get_login_packet(client_fd,buffer);
	parse_login_packet(buffer,username);

	if (strcmp(plug_server,""))
		strcpy(dest,plug_server);
	else if (transparent)
		get_transparent_dst(dest);
	else if (p = strrchr(username,'@')) {
		*p++ = '\0';
		if (*p == '\0') {
			syslog(LLEV,"NULL destination");
			login_failure(client_fd);
			proxy_exit(1);
		} else {
			strncpy(dest,p,sizeof(dest));
			set_username(buffer,username);
		}
	} else {
		syslog(LLEV,"destination not specified");
		login_failure(client_fd);
		proxy_exit(1);
	}
		
	if (check_dest(dest))
		exit(1);

	if (check_user(username)) {
		syslog(LLEV,"deny host=%.512s/%.20s access for user %s",rladdr,riaddr,username);
		login_failure(client_fd);
		proxy_exit(0);
	}

	if (loguser)
		syslog(LLEV,"permit host=%.512s/%.20s access for user %s",rladdr,riaddr,username);

	if((server_fd = conn_server(dest,server_port,0,(char *)0)) <0) {
		syslog(LLEV,"cannot connect to server: %m");
		exit(1);
	}
	server_fds = server_fd;

	switch (server_encrypt) {
	case 	CRYPT_NONE:
		break;
	case	CRYPT_BF:
		scrypto_pid = spawn_bf(server_fd,server_pipe,srv_bfkey);
		server_fd = server_pipe[0];
	}

	send_login_packet(server_fd,buffer);

	setsockopt(0,SOL_SOCKET,SO_OOBINLINE,(char *)&opt,optlen);
	signal(SIGURG,SIG_IGN);
	signal(SIGPIPE,SIG_IGN);

	while(1) {

		FD_ZERO(&rset);
		FD_SET(client_fd,&rset);
		FD_SET(server_fd,&rset);
		timo.tv_sec = timeout;
		timo.tv_usec = 0;
		if((x = select(server_fd+1, &rset, NULL, NULL, &timo)) < 0) {
			if (errno != EBADF && errno != EINTR)
				syslog(LLEV,"fwtksyserr: select: %m");
			exit(1);
		} else {
			if(x == 0) {
				syslog(LLEV,"Network timeout signal after %d seconds", timeout);
				break;
			}
		}

		if (FD_ISSET(client_fd,&rset))
		{
			ioctl(client_fd,FIONREAD,&x);
			if (x <= 0)
				break;
			if (net_read(client_fd,(char *)header,sizeof(tds_header)) < 0)
				break;
			check_header(header,0);
			if ((data_size = ntohs(header->length) - 8) >= sizeof(buffer)) {
				syslog(LLEV,"fwtksyserr: buffer size exceeded on client socket, protocol failed");
				exit(1);
			}

			if ((send_oob) && (header->msgtype == MSG_CANCEL)) {
				if (data_size != 0)
					syslog(LLEV,"cancel message has non-empty data section,ignored");
				if(write(server_fd,header,sizeof(tds_header)-1) < sizeof(tds_header)-1) 
					break;
/*
 *				We send OOB byte bypassing encryption engine
 */
				send(server_fds,&header->window,1,MSG_OOB);
			} else {
				if (net_read(client_fd,data,data_size) < 0)
					break;

				if(x = write(server_fd,buffer,sizeof(tds_header)+data_size) < sizeof(tds_header)+data_size) 
					break;
			}
			
			ob += data_size + 8;
		}
		if (FD_ISSET(server_fd,&rset))
		{
			ioctl(server_fd,FIONREAD,&x);
			if (x <= 0)
				break;
			if (net_read(server_fd,(char *)header,sizeof(tds_header)) < 0)
				break;
			check_header(header,1);
			if ((data_size = ntohs(header->length) - 8) >= sizeof(buffer)) {
				syslog(LLEV,"fwtksyserr: buffer size exceeded on client socket, protocol failed");
				exit(1);
			}
			if (net_read(server_fd,data,data_size) < 0)
				break;

			if(x = write(client_fd,buffer,sizeof(tds_header)+data_size) < sizeof(tds_header)+data_size) 
				break;
			ib += data_size + 8;
		}
	}
	close(server_fd);
	close(server_fds);
	close(client_fd);
	shutdown(client_pipe[0],2);
	shutdown(server_pipe[0],2);
	proxy_exit(0);
}

