/**
 * @file   gsb_common.h
 * @author Alex Ott <alexott@gmail.com>
 * 
 * @brief  Common functions and structures for gsb api
 * 
 * 
 */

#ifndef GSB_COMMON_H
#define GSB_COMMON_H

#include <sys/types.h>
#include <sys/stat.h>
#include <string.h>
#include <stdlib.h>

/**
 * 
 * 
 */
typedef struct {
	struct timespec modtime;
	char* name;
	int minor_version;
	int major_version;
	unsigned int count;
	/* actual data - depending on how they will stored  */
} gsb_file;

void gsb_free_file(gsb_file*);
gsb_file* gsb_read_file(const char*);
gsb_file* gsb_init_file(const char*);

#endif /* GSB_COMMON_H */
