/**
 * @file   urldb_cl_api.h
 * @author Alex Ott <alexott@gmail.com>
 * 
 * @brief  Client API for URL Db
 * 
 * 
 */

#ifndef URLDB_CL_API_H
#define URLDB_CL_API_H

#include <stdlib.h>

typedef unsigned int url_category;

#define URLDB_MAJOR_CAT(x) ((x & 0xff00) >> 8)
#define URLDB_MINOR_CAT(x) ((x & 0x00ff))

int urldb_init();
int urldb_fini();

char** urldb_get_available_modules();
int urldb_add_module();
int urldb_remove_module();

int urldb_get_category(const char*, url_category*, int);

void urldb_set_option_int(int, long int);
long int urldb_get_option_int(int);
void urldb_set_option_string(int,const char*);
const char* urldb_get_option_string(int);


#endif /* URLDB_CL_API_H */
