/**
 * @file   urldb_pl_common.h
 * @author Alex Ott <alexott@gmail.com>
 * 
 * @brief  Common functions and definitions for all plugins
 * 
 * 
 */

#ifndef URLDB_PL_COMMON_H
#define URLDB_PL_COMMON_H

#include <stdlib.h>

typedef int (*plugin_init_func)(void);
typedef int (*plugin_fini_func)(void);
typedef int (*plugin_lookup_func)(const char* url, int** buf, int size);

typedef struct {
	plugin_init_func   init_func;
	plugin_fini_func   fini_func;
	plugin_lookup_func lookup_func;
} urldb_plugin_descriptor;


typedef int urldb_plhandle;

/* functions from urldb core component */
urldb_plhandle urldb_core_register_plugin(const char* plname, urldb_plugin_descriptor dsc);
int urldb_core_remove_plugin(urldb_plhandle plhandle);

#endif /* URLDB_PL_COMMON_H */
