/**
 * @file   urldb_pl_gsb.c
 * @author Alex Ott <alexott@gmail.com>
 * 
 * @brief  URL Db plugin for Google Safe Browsing API
 * 
 * 
 */

#include "urldb_pl_common.h"
#include "gsb_common.h"

/* global variables */
static gsb_file *black_list=NULL, *malware_list=NULL;

/** 
 * Perform update of data if update available
 * 
 * @param file 
 * 
 * @return 
 */
int gsb_update_file(gsb_file* file) {
	
	return 0;
}

/** 
 * 
 * 
 * 
 * @return 0 on success, -1 on error
 */
int gsb_init_func(void) {
	if(!black_list) {
		black_list=gsb_read_file("gsb_blacklist.txt");
		if(!black_list)
			black_list=gsb_init_file("black");
	}
	if (!malware_list) {
		malware_list=gsb_read_file("gsb_malwarelist.txt");
	    if(!malware_list)
			malware_list=gsb_init_file("malware");
	}
	
	return (black_list != NULL && malware_list != NULL ? 0 : -1);
}

/** 
 * 
 * 
 * 
 * @return 
 */
int gsb_fini_func(void) {
	if(!black_list) {
		gsb_free_file(black_list);
		black_list=NULL;
	}
	if (!malware_list) {
		gsb_free_file(malware_list);
		malware_list=NULL;
	}
	
	return 0;
}

int gsb_lookup_func(const char* url, int** buf, int size) {
	return 0;
}

/* static initialization of module */
urldb_plugin_descriptor gsb_descriptor = {
	gsb_init_func,
	gsb_fini_func,
	gsb_lookup_func
} ;

